defmodule TrixtaMetricsTest do
  use ExUnit.Case
  doctest TrixtaMetrics

  setup do
    id = UUID.uuid1()

    metric_plain_map = %{
      "id" => id,
      "name" => "Genèsis Plain",
      "description" => "The Genèsis Plain Metric",
      "current_state" => :initialising
    }

    metric1_plain_map = %{
      "name" => "Genèsis One Plain",
      "description" => "The Genèsis One Plain Metric",
      "current_state" => :initialising
    }

    metric = %TrixtaMetrics.Metric{
      id: id,
      name: "Genèsis",
      description: "The Genèsis Metric",
      current_state: :initialising
    }

    metric1 = %TrixtaMetrics.Metric{
      name: "Genèsis One",
      description: "The Genèsis One Metric",
      current_state: :initialising
    }

    [
      metric_plain_map: metric_plain_map,
      metric1_plain_map: metric1_plain_map,
      metric: metric,
      metric1: metric1
    ]
  end

  test "start_metric without params starts a new metric with defaults" do
    assert {:ok, pid, new_metric} = TrixtaMetrics.start_metric()

    assert TrixtaMetrics.MetricServer.metric_pid(new_metric.id) == pid
    assert new_metric.id != nil
    assert new_metric.name =~ ~r/^[a-z]+-[a-z]+-[0-9]+/
    assert new_metric.description =~ ~r/.+/
    assert new_metric.current_state == :initialising
  end

  test "start_metric starts a new metric with given state plain map", %{
    metric_plain_map: metric_plain_map
  } do
    assert {:ok, pid, new_metric} = TrixtaMetrics.start_metric(metric_plain_map)

    assert TrixtaMetrics.MetricServer.metric_pid(new_metric.id) == pid
    assert new_metric.id != nil
    assert new_metric.id == metric_plain_map["id"]
    assert new_metric.name == "Genèsis Plain"
    assert new_metric.description == "The Genèsis Plain Metric"
    assert new_metric.current_state == :initialising
  end

  test "start_metric starts a new metric with given state struct", %{metric: metric} do
    assert {:ok, pid, new_metric} = TrixtaMetrics.start_metric(metric)

    assert TrixtaMetrics.MetricServer.metric_pid(new_metric.id) == pid
    assert new_metric.id != nil
    assert new_metric.id == metric.id
    assert new_metric.name == "Genèsis"
    assert new_metric.description == "The Genèsis Metric"
    assert new_metric.current_state == :initialising
  end

  test "start_metric without an ID starts a new metric with given state plain map and autogenerated ID",
       %{
         metric1_plain_map: metric1_plain_map
       } do
    assert {:ok, pid, new_metric} = TrixtaMetrics.start_metric(metric1_plain_map)

    assert TrixtaMetrics.MetricServer.metric_pid(new_metric.id) == pid
    assert new_metric.id != nil
    assert new_metric.name == "Genèsis One Plain"
    assert new_metric.description == "The Genèsis One Plain Metric"
    assert new_metric.current_state == :initialising
  end

  test "start_metric without an ID starts a new metric with given state struct and autogenerated ID",
       %{
         metric1: metric1
       } do
    assert {:ok, pid, new_metric} = TrixtaMetrics.start_metric(metric1)

    assert TrixtaMetrics.MetricServer.metric_pid(new_metric.id) == pid
    assert new_metric.id != nil
    assert new_metric.name == "Genèsis One"
    assert new_metric.description == "The Genèsis One Metric"
    assert new_metric.current_state == :initialising
  end

  test "stop_metric stops a given metric", %{metric: metric} do
    assert {:ok, pid, metric} = TrixtaMetrics.start_metric(metric)
    assert TrixtaMetrics.stop_metric(metric.id) == :ok
    assert TrixtaMetrics.MetricServer.metric_pid(metric.id) == nil
  end

  test "terminate_metric terminates a named metric", %{metric: metric} do
    assert {:ok, pid, metric} = TrixtaMetrics.start_metric(metric)
    assert TrixtaMetrics.terminate_metric(metric.id) == :ok
    assert TrixtaMetrics.MetricServer.metric_pid(metric.id) == nil
  end
end
